#include<iostream>
#include<cmath>
using namespace std;
int main(){
    int t,n,m;
    cin>>t;
    int broj[t],k,a,w;
    for(int i=0;i<t;i++){
    	cin>>n>>m;
    	int da[n],ne[m];
    	for(int l=0;l<n;l++){
    		cin>>da[l];
		}
		for(int l=0;l<m;l++){
    		cin>>ne[m];
		}
		a=abs(da[0]-da[1]);
		for(int l=2;l<=a;l++){
			k=1;
			for(int q=0;q<n;q++){
				if(q==0)w=da[q]%l;
				if(da[q]%l!=w)k=0;break;
			}
			if(k==1)for(int q=0;q<m;q++){
				if(ne[q]%l==w)k=0;break;
			}
		}
		broj[i]=k;
	}
	for(int i=0;i<t;i++){
		cout<<broj[i]<<endl;
	}
	return 0;
}